#include <iostream>
#include <algorithm>
using namespace std;

int main () {
  int S;
  cin >> S;
  for( int s=1; s<=S; s++ ){
    cout << "Scenario #" << s << ":" << endl;
    
    //--- Listen.
    int n;
    cin >> n;
    int a[n];
    for( int i=0; i<n; i++ )
      cin >> a[i];
    
    //--- Dance...
    sort( a, a+n );
    int bestR = 1<<30, bestI = 0;
    for( int i=0; i+4<n; i++ ){
      int r = a[i+4] - a[i] + 1;
      if( r < bestR ){
	bestR = r;
	bestI = i;
      }
    }
    
    //--- Answer.
    cout << bestR << ":";
    for( int j=0; j<5; j++ )
      cout << " " << a[bestI+j];
    cout << endl << endl;
  }
}
